aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJohn Levon <john.levon@nutanix.com>2022-04-28 15:29:34 +0100
committerGitHub <noreply@github.com>2022-04-28 15:29:34 +0100
commite47daa3ca898d9cfaed8630a01519cd51fc4aeea (patch)
tree306e075cbd83b94fc96d062d367b7beccccd36e5
parent418f58bfc8c23ebcf0deb3bb85967587fa51acf7 (diff)
downloadlibvfio-user-e47daa3ca898d9cfaed8630a01519cd51fc4aeea.zip
libvfio-user-e47daa3ca898d9cfaed8630a01519cd51fc4aeea.tar.gz
libvfio-user-e47daa3ca898d9cfaed8630a01519cd51fc4aeea.tar.bz2
test library linkage (#665)
Add a cheesy test for identifying functions in the public header that are not exported. Signed-off-by: John Levon <john.levon@nutanix.com> Reviewed-by: Thanos Makatos <thanos.makatos@nutanix.com>
-rw-r--r--test/CMakeLists.txt5
-rwxr-xr-xtest/test-linkage.sh51
2 files changed, 56 insertions, 0 deletions
diff --git a/test/CMakeLists.txt b/test/CMakeLists.txt
index 2f085b8..44ba014 100644
--- a/test/CMakeLists.txt
+++ b/test/CMakeLists.txt
@@ -56,3 +56,8 @@ enable_testing()
add_test(NAME unit-tests COMMAND ${valgrind} ${CMAKE_CURRENT_BINARY_DIR}/unit-tests)
add_test(NAME lspci COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-lspci.sh)
add_test(NAME client-server COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-client-server.sh)
+
+if (NOT WITH_ASAN EQUAL 1)
+add_test(NAME linkage COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-linkage.sh
+ ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_C_COMPILER})
+endif()
diff --git a/test/test-linkage.sh b/test/test-linkage.sh
new file mode 100755
index 0000000..307468f
--- /dev/null
+++ b/test/test-linkage.sh
@@ -0,0 +1,51 @@
+#!/bin/bash
+#
+# Copyright (c) 2022 Nutanix Inc. All rights reserved.
+#
+# Authors: John Levon <john.levon@nutanix.com>
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+# * Neither the name of Nutanix nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
+# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+#
+# A crappy way to check all "public" symbols are exported.
+#
+
+set -e
+
+header="$1/include/libvfio-user.h"
+libdir="$2/lib"
+cc="$3"
+
+tmpfile=$(mktemp /tmp/libvfio-user.test-linkage.XXXXXX.c)
+cat >$tmpfile <<EOF
+int main() {
+
+$(egrep '^[a-z_0-9]+\(' $header | sed 's+(.*+();+;')
+
+}
+EOF
+
+$cc -Wno-implicit-function-declaration -o /dev/null $tmpfile $libdir/libvfio-user.so
+
+rm $tmpfile